# Copyright (c) 2015 Dave Love, Liverpool University
# MIT licence, per Fedora policy.

# fixme: ship Utils, Examples?
# fixme: bundled: fdf, xmlf90, 

%bcond_with mpich

Name:           siesta
Version:        4.0.2
Release:        1%{?dist}
Summary:        A first-principles materials simulation code using DFT
# fixme: other components
License:        GPLv3 and BSD
URL:            http://departments.icmab.es/leem/siesta/
Source0:        https://launchpad.net/siesta/4.0/%version/+download/siesta-%version.tar.gz
BuildRequires:  openblas-devel netcdf-fortran-devel

%global desc \
SIESTA is both a method and its computer program implementation, to\
perform efficient electronic structure calculations and ab initio\
molecular dynamics simulations of molecules and solids.  SIESTA's\
efficiency stems from the use of strictly localized basis sets and\
from the implementation of linear-scaling algorithms which can be\
applied to suitable systems.  A very important feature of the code is\
that its accuracy and cost can be tuned in a wide range, from quick\
exploratory calculations to highly accurate simulations matching the\
quality of other approaches, such as plane-wave and all-electron\
methods.\
\
The possibility of treating large systems with some first-principles\
electronic-structure methods has opened up new opportunities in many\
disciplines.  The SIESTA program is distributed freely to academics and\
has become quite popular, being increasingly used by researchers in\
geosciences, biology, and engineering (apart from those in its natural\
habitat of materials physics and chemistry).  Currently there are\
several thousand users all over the world, and the paper describing\
the method (J. Phys. Cond. Matt. 14, 2745 (2002)) has received more\
than 6000 citations so far.

%description

%package openmpi
Summary:        A first-principles materials simulation code using DFT - openmpi
BuildRequires:	openmpi-devel scalapack-openmpi-devel 
Requires:       scalapack-openmpi%{?_isa}
Provides:       bundled(FoXlibf)

%description openmpi
%desc

This is the openmpi version.

%if %{with mpich}
%package mpich
Summary:        A first-principles materials simulation code using DFT - mpich
BuildRequires:  mpich-devel scalapack-mpich-devel
Requires:       scalapack-mpich%{?_isa}
Provides:       bundled(FoXlibf)

%description mpich
%desc

This is the mpich version.
%endif


%prep
%setup -q


%build
%global _configure ../Src/configure
cd Obj
../Src/obj_setup.sh
export FCFLAGS='-O3 -funroll-loops -I%_fmoddir'
%_openmpi_load
%configure --enable-mpi --with-blas=-lopenblas --with-lapack=-lopenblas --with-netcdf=-lnetcdff
make # not smp-safe
%_openmpi_unload
mv siesta siesta.openmpi
%if %{with mpich}
make clean
%_mpich_load
%configure --enable-mpi --with-blas=-lopenblas --with-lapack=-lopenblas --with-netcdf=-lnetcdff
make # not smp-safe
%_mpich_unload
mv siesta siesta.mpich
%endif


%install
mkdir -p %buildroot%_libdir/{openmpi,mpich}/bin
install -m 655 Obj/siesta.openmpi %buildroot%_libdir/openmpi/bin
%if %{with mpich}
install -m 655 Obj/siesta.mpich %buildroot%_libdir/mpich/bin
%endif


%{!?_licensedir:%global license %doc}
%files openmpi
%doc AUTHORS README
%license COPYING NOTICE.txt
%_libdir/openmpi/bin/siesta.openmpi

%if %{with mpich}
%files mpich
%doc AUTHORS README
%license COPYING NOTICE.txt
%_libdir/mpich/bin/siesta.mpich
%endif


%changelog
* Fri May 17 2019 Dave Love <loveshack@fedoraproject.org> - 4.0.2-1
- New version

* Thu Jun 30 2016 Dave Love <loveshack@fedoraproject.org> - 4.0-1
- Initial packaging
